var Ci = Components.interfaces;
var Cc = Components.classes;
var rdrPref = {
  prefs: Cc['@mozilla.org/preferences-service;1'].getService(Ci.nsIPrefService).getBranch('extensions.rdr.'),
  boolPrefs1: Array('chbWhitelist','chbContextOpen','chbCopyClean','chbCleanImages','chbStatusButton','chbChangeCursor'),
  boolPrefs2: Array('contextmenu.whitelist','contextmenu.contextopen','contextmenu.copyclean','cleanImages','statusbutton','changeCursor'),
  init: function() {
    this.defaultFilters=Cc['@mozilla.org/preferences-service;1'].getService(Ci.nsIPrefService).getDefaultBranch('extensions.rdr.').getCharPref('whitelist');
    this._filters=' ';
	  this.list=document.getElementById('permissionsBox');
		this._bundle = document.getElementById("bundlePreferences");
	  this.fillList(); // Fills ignore-List
    for(var i=0;i<this.boolPrefs1.length;i++)
      document.getElementById(this.boolPrefs1[i]).checked=this.prefs.getBoolPref(this.boolPrefs2[i]);

		document.getElementById("removeAllPermissions").disabled = this.list.getRowCount() == 0;
    
    
    if(window.arguments[0]) {
      var textbox = document.getElementById("url");
      textbox.value=window.arguments[0];
      this.onHostInput(textbox);
    }
  },
		
  onHostInput: function () {
    document.getElementById("btnAllow").disabled = !document.getElementById("url").value.replace(/^\s*([-\w]*:\/+)?/, "");
  },
	
	save: function () {
    for(var i=0;i<this.boolPrefs1.length;i++)
      this.prefs.setBoolPref(this.boolPrefs2[i],document.getElementById(this.boolPrefs1[i]).checked);

    this.prefs.setCharPref('whitelist',this.getListBoxValues());  
  },
  	
	fillList:	function () {
		var items,item,prefIgnore=this.prefs.getCharPref('whitelist');
		if((prefIgnore.replace(/^\s*|\s*$/g,"")).length==0) return;
		items=prefIgnore.split(' ');
		for(var i=0;i<items.length;i++) this.addItem(items[i],(window.arguments && window.arguments[1]==items[i]),false);
	},
  
  addItem: function(filter,select,check,overwrite) {
    if (check && this.filterExists(filter)) return;
    
    this._filters=(this._filters+filter+' ').toLowerCase();
    newItem=this.list.appendItem(filter, filter);
    if((' '+this.defaultFilters+' ').indexOf(' '+filter+' ')>=0) newItem.setAttribute("style","font-style:italic");
    
    if(select) {
      this.onHostInput();
      document.getElementById("removeAllPermissions").disabled = this.list.getRowCount() == 0;
      window.setTimeout('l=rdrPref.list;i=l.getItemAtIndex('+rdrPref.list.getIndexOfItem(newItem)+');l.selectItem(i);l.ensureElementIsVisible(i);',0);
    }
  },
  
  filterExists: function(f) {
    if(this._filters.indexOf(' '+f.toLowerCase()+' ')>=0) return true;
    return false;
  },
  
  addDefaultFilters:	function () {
		var items=this.defaultFilters.split(' ');
		for(var i=0;i<items.length;i++) this.addItem(items[i],false,true);
	},
	
	addPermission: function () {
    var textbox = document.getElementById("url");
    var host = textbox.value.toLowerCase();
    if(host.indexOf('*')==-1) { // Normal URL matching
      host = host.replace(/^\s*([-\w]*:\/+)?/, ""); // trim any leading space and scheme
  		var promptService = Cc["@mozilla.org/embedcomp/prompt-service;1"].getService(Ci.nsIPromptService);
      try {
        var ioService = Cc["@mozilla.org/network/io-service;1"].getService(Ci.nsIIOService);
        var uri = ioService.newURI("http://"+host, null, null);
      } catch(ex) {
        var message = this._bundle.getString("invalidURI");
        var title = this._bundle.getString("invalidURITitle");
        promptService.alert(window, title, message);
  			textbox.focus();
        return;
      }
  		host=host.match(/^[^/?]+/);
      host=host[0];
    } else host = host.replace(/^\**|\**$/g,"").replace(/\*+/g,"*"); // Trims asteriks, removes double (or more) asteriks 

    this.addItem(host,true,true);
    textbox.focus();
  },
	
	onPermissionKeyPress: function (aEvent) {
    if (aEvent.keyCode == 46)
      this.onPermissionDeleted();
  },
	
	onPermissionSelected: function () {
    var hasSelection = this.list.selectedCount > 0;
    var hasRows = this.list.getRowCount() > 0;
    document.getElementById("removePermission").disabled = !hasRows || !hasSelection;
    document.getElementById("removeAllPermissions").disabled = !hasRows;
  },
	
	onPermissionDeleted: function () {
    if (!this.list.getRowCount()) return;
    var item=this.list.getSelectedItem(0);
    this._filters=this._filters.split(' '+item.label+' ').join(' ');
		var itemId=this.list.getIndexOfItem(item);
    this.list.removeItemAt(itemId);
    document.getElementById("removePermission").disabled = !this.list.getRowCount();
    document.getElementById("removeAllPermissions").disabled = !this.list.getRowCount();
		if(this.list.getRowCount()) this.list.selectedIndex=itemId == 0?0:itemId-1;
  },
	
	onAllPermissionsDeleted: function () {
    if (!this.list.getRowCount()) return;
		while(this.list.getRowCount()) this.list.removeItemAt(0);
    this._filters=' ';
    document.getElementById("removePermission").disabled = true;
    document.getElementById("removeAllPermissions").disabled = true;
  },
	
	getListBoxValues: function() {
		return this._filters.replace(/^\s*|\s*$/g,"");
	},
  
  d: function(t) {
	  Cc["@mozilla.org/consoleservice;1"].getService(Ci.nsIConsoleService).logStringMessage('rdr: '+t);
  }	
}
