// contact me if you need help understanding the functions, xeen
Cc=Components.classes;
Ci=Components.interfaces;

var rdr = {
  preventClean: false,
  prefServ: Cc['@mozilla.org/preferences-service;1'].getService(Ci.nsIPrefService),
  fixup: Cc["@mozilla.org/docshell/urifixup;1"].getService(Ci.nsIURIFixup),
  hist: Cc["@mozilla.org/browser/global-history;2"].getService(Ci.nsIGlobalHistory2),
  // Adds all kinds of observers & injects code in order to clean links
	init: function (all) {    
    window.removeEventListener("load",function() { rdr.init(true); }, false);    
    window.addEventListener("unload", function() { rdr.prefs = null; }, false); 
    
    rdr.locale=rdr.getById("rdrLocale");
    
    rdr.prefs=rdr.prefServ.getBranch('extensions.rdr.');
    rdr.prefs.QueryInterface(Components.interfaces.nsIPrefBranch2);
		rdr.prefs.addObserver("", this, false);    
    rdr.updatePrefs();
    
    if(all) {    
      getBrowser().addEventListener("click", rdr.catchClick, true);
      getBrowser().addEventListener("mousedown", rdr.catchMouseDown, true);
      if(rdr.getById("cmd_copyLink")) rdr.getById("cmd_copyLink").setAttribute("oncommand", "rdr.resetLink();goDoCommand('cmd_copyLink')"); // 2.0
      if(rdr.getById("context-copylink")) rdr.getById("context-copylink").setAttribute("oncommand", "rdr.resetLink();goDoCommand('cmd_copyLink')"); // 3.0

      var context=rdr.getById("contentAreaContextMenu");
      if(context) {
        context.addEventListener("popupshowing", function(event) { rdr.contextMenuCheck(event); }, false);
        context.addEventListener("popuphiding",  function(event) { rdr.contextMenuClean(event); }, false);
      }
      
      var appcontent = rdr.getById("appcontent");
      if(appcontent) appcontent.addEventListener("DOMContentLoaded", rdr.cleanImgs, true);
      
      // Code injecting functions need to be delayed
      window.setTimeout("rdr.delayedInit();",10);  
    }
	},
  
  getById: function(t) {
    return window.document.getElementById(t);
  },
  
  delayedInit: function() {  
    // For URLs in the statusbar
    if(nsBrowserStatusHandler) {
      eval("nsBrowserStatusHandler.prototype.setOverLink="+nsBrowserStatusHandler.prototype.setOverLink.toString().replace(
      'this.overLink = link;',
      'if(link=="") rdr.resetLink(true); rdrUL=rdr.findLink(link); this.overLink=unescape(rdrUL)==link?unescape(rdr.cleanLink(rdrUL,true)):link;'
      ));
      // Work around needed because provided link is already escaped which makes correct cleaning impossible
      // Reset Link after Drag&Drop here
    }
       
    try {
      // TabMix function "open multiple links". This might change in future versions, so additional checking might be needed
      if(window.openMultipleLinks) {
        eval("openMultipleLinks="+openMultipleLinks.toString().replace(
        'newTab =',
        'nextEpisode.href=rdr.cleanLink(nextEpisode.href,false); newTab ='
        ));
      } 
    } catch(e){}
    
    try {
      // AiO-Gestures should use cleaned links 
      if(window.aioGetHRef) {
        eval("aioGetHRef="+aioGetHRef.toString().replace(
        'node.href',
        'rdr.cleanLink(node.href,false);'
        ));
        eval("aioGetHRef="+aioGetHRef.toString().replace(
        'makeURLAbsolute(node.baseURI, node.getAttributeNS(xlinkNS, "href"))',
        'rdr.cleanLink(makeURLAbsolute(node.baseURI, node.getAttributeNS(xlinkNS, "href")),false);'
        ));
      }
    } catch(e){}
    
    try {
      // Smart Middle Click shouldn't open links if RDR can do it instead
      if(window.contentAreaClick2) {
        eval("contentAreaClick2="+contentAreaClick2.toString().replace(
        'wrapper = linkNode;',
        'wrapper = linkNode; '+
        'if(wrapper.href!=rdr.cleanLink(wrapper.href,false)) return false;'
        ));
      } 
    } catch(e){}
  },
  
  catchMouseDown: function(aEvt) {
    if (aEvt.button==0) {
		  var wrapper=rdr.getLinkNode(aEvt);
      if(!wrapper || !wrapper.hasAttribute("href")) return;
      var clean=rdr.cleanLink(wrapper.href,false);
      if(clean==wrapper.href) return false;
      
      rdr.origlinkURL2=new Array(wrapper,wrapper.href);
      wrapper.href=clean;  
    }
  },
    
  catchClick: function(aEvt) {
    if (aEvt.button!= 2 && rdr.contentAreaClick(aEvt)) // button=2 == right click
		  aEvt.stopPropagation();
  },
  
  isLinkElement: function(a) {
    return ((a instanceof HTMLAnchorElement || a instanceof HTMLAreaElement || a instanceof HTMLLinkElement) && a.hasAttribute("href"));
  },
  
  getLinkNode: function(event) {
    var target = event.originalTarget;
    var linkNode = false;
    
    for(x in event) rdr.d("getLinkNode "+x+": "+event[x]);
    
    if (rdr.isLinkElement(target)) linkNode = target;

    if(!linkNode) {
      var parent = target.parentNode;
      while (parent) {
        if (rdr.isLinkElement(parent)) linkNode = parent;
        parent = parent.parentNode;
      }
    }
    return linkNode;
  },
    
  contentAreaClick: function(event) {
    if(rdr.preventClean) return false;
    
    linkNode=rdr.getLinkNode(event);
        
  	var wrapper = null;
  	if (!linkNode) {
      rdr.d("Link not found");
      return false;
    }

    wrapper = linkNode;

    clean=rdr.cleanLink(wrapper.href,false);
    if(clean==wrapper.href) return false;

    // Add uncleaned link to history as well, so it's displayed as visited
    rdr.addURLToHistory(wrapper.href,linkNode);
    
    rdr.origlinkURL=new Array(wrapper,wrapper.href);
    window.setTimeout("rdr.resetLink();",0);
    
    wrapper.href=clean;
    handleLinkClick(event, clean, wrapper);  
    return true;
  },
  
  addURLToHistory: function(url,node) {
    uri = rdr.fixup.createFixupURI(url, 0);
    if (!rdr.hist.isVisited(uri)) {
      rdr.hist.addURI(uri, false, true, null);
      var oldHref = node.getAttribute("href");
      if (typeof oldHref == "string") {
        node.setAttribute("href", "");
        node.setAttribute("href", oldHref);
      }
    }
    return url;
  },
    
  cleanImgs: function(e) {
    var doc = e.originalTarget;
    if(doc.nodeName != "#document" || !rdr.cleanImgsOnLoad || !doc.images || doc.images.length==0) return;
    for(var i=0;i<doc.images.length;i++) {
      tmp=rdr.cleanLink(doc.images[i].src,false);
      if(doc.images[i] && tmp!=doc.images[i].src) {
        doc.images[i].setAttribute("origsrc",doc.images[i].src);
        doc.images[i].setAttribute("src",tmp);
      }
    }
  },
 
  findLink: function(link) {
    frames=rdr.catchFrames(content,new Array());
    for(var f=0;f<frames.length;f++) {
      links=frames[f].links;
      if(!links) continue;
      for(var i=0;i<links.length;i++) {
        if(unescape(links[i].href)==link) {
          if(rdr.overLink) rdr.overLink.style.cursor = "";
          rdr.overLink=links[i];
          return links[i].href;
        }
      }   
    }
    return "link not found: "+link;
  },
   
  updatePrefs: function() {
    var t = rdr.prefs.getCharPref("whitelist").toLowerCase();
    rdr.whitelist        = t.length?t.split(" "):new Array();
    rdr.contextWhitelist = rdr.prefs.getBoolPref("contextmenu.whitelist");
    rdr.contextCopyClean = rdr.prefs.getBoolPref("contextmenu.copyclean");
    rdr.contextOpen      = rdr.prefs.getBoolPref("contextmenu.contextopen");
    rdr.contextOpenIn    = rdr.prefs.getIntPref ("contextmenu.contextopen.in");
    rdr.cleanImgsOnLoad  = rdr.prefs.getBoolPref("cleanImages");
    rdr.statusButton     = rdr.prefs.getBoolPref("statusbutton");
    rdr.enabled          = rdr.prefs.getBoolPref("enabled");
    rdr.debug            = rdr.prefs.getBoolPref("debug");
    rdr.askBeforeRemoval = rdr.prefs.getBoolPref("askBeforeRemoval");
    rdr.intelliWhitelist = rdr.prefs.getBoolPref("intelliWhitelist");
    rdr.blacklist        = rdr.prefs.getBoolPref("blacklist");
    rdr.changeCursor     = rdr.prefs.getBoolPref("changeCursor");
    
    try {      
      b=rdr.getById('rdr-button');    
      b.setAttribute('isenabled',rdr.enabled);
      b.setAttribute('label',rdr.locale.getString(rdr.enabled?"rdrIsOn":"rdrIsOff"));
    } catch(e) {}
     
    b=rdr.getById('rdr-status-button');   
    if(!b) return;    
    if(rdr.statusButton) {
      b.setAttribute('isenabled',rdr.enabled);
      b.setAttribute('hidden','false');
      b.setAttribute('collapsed','false');
    } else {
      b.setAttribute('hidden','true');
      b.setAttribute('collapsed','true');
    } 
  },
  
  catchFrames: function(e,arr) {
		arr[arr.length]=e.document;
		if (!("frames" in e) || e.frames.length <= 0) return arr;
	  for (var f = 0; f < e.frames.length; f++) {
			try {
				arr=rdr.catchFrames(e.frames[f],arr);						
			} catch(err) { rdr.d('err: '+err); }
		}  		
	
		return arr;
  },
  
  buttonMenuCheck: function(event) {
    ev=event.target;  
    rdr.menu=ev;
    // Clean previous entries
    while(x=ev.firstChild) ev.removeChild(x);

    hasItems=false;
    showedHosts=' ';
    try {
      frames=rdr.catchFrames(content,new Array());
      for(var f=0;f<frames.length;f++) {
        links=frames[f].links;
        for(var i=0;i<links.length;i++) {
          if(links[i].href==rdr.removeR(links[i].href)) continue;
          showedHosts=rdr.addMenuItem(ev,links[i].href,links[i],showedHosts);
          hasItems=true;
        }   
          
        if(rdr.cleanImgsOnLoad) { 
          imgs=frames[f].images;
          for(var i=0;i<imgs.length;i++) {
            // Prevent fakes by webmasters
            origSrc=imgs[i].hasAttribute("origsrc");
            if((origSrc && imgs[i].src==rdr.removeR(imgs[i].getAttribute("origsrc"))) || imgs[i].src!=rdr.removeR(imgs[i].src)) {
              showedHosts=rdr.addMenuItem(ev,imgs[i].getAttribute(origSrc?"origsrc":'src'),imgs[i],showedHosts);
              hasItems=true;
            }
          }
    		}
      }  
    } catch(e) { rdr.d('Unsupported document type'); }
    
    if(!hasItems) {
      item = document.createElement("menuitem");
      item.setAttribute("label", rdr.locale.getString('buttonNords'));
      item.setAttribute("disabled", "true");
      ev.appendChild(item);
    }
    
    ev.appendChild(document.createElement("menuseparator"));
    
    item = document.createElement("menuitem");
    item.setAttribute("label", rdr.locale.getString('buttonOpenoptions'));
    item.setAttribute("accesskey", rdr.locale.getString('buttonOpenoptionsAccesskey'));
    item.setAttribute("oncommand", "rdr.openOptions();");
    ev.appendChild(item);
    
    item = document.createElement("menuitem");
    item.setAttribute("label", rdr.locale.getString('buttonEnablerdr'));
    item.setAttribute("accesskey", rdr.locale.getString('buttonEnablerdrAccesskey'));
    item.setAttribute("oncommand", "rdr.prefs.setBoolPref('enabled',!rdr.enabled);");
    item.setAttribute("type", "checkbox");
    item.setAttribute("checked", rdr.enabled);
    ev.appendChild(item);
  },
  
  addMenuItem: function(ev,link,node,showedHosts) {
    host=rdr.getHost(link,node);
    rdr.d('Found '+host+' ('+link+')');
    if(showedHosts.indexOf(' '+host+' ')>=0) return showedHosts;
    showedHosts+=host+' ';          
    whtl=rdr.isWhitelisted(link,true);
    item = document.createElement("menuitem");
    item.setAttribute("id", "rdr-"+(whtl?'remove-from':'add-to')+"-list");
    item.setAttribute("class", "menuitem-iconic");
    item.setAttribute("label", whtl?whtl:host);
    item.setAttribute("tooltiptext", link);
    item.setAttribute("oncommand", (whtl?'rdr.removeLinkFromList':'rdr.addLinkToList')+'(this.getAttribute("tooltiptext"))');
    item.setAttribute("onclick", 'if(event.button==1) rdr.openOptions(this.getAttribute("tooltiptext")'+(whtl?',this.getAttribute("label")':'')+');');
    item.setAttribute("checked",whtl?'true':'false');
    ev.appendChild(item);
    return showedHosts;
  },
    
  contextMenuCheck: function(event) {
    if(event.target.getAttribute('id')!='contentAreaContextMenu' || !gContextMenu) return;
    if(rdr.origlinkURL == null) {
      link=gContextMenu.linkURL;
      isOnList=rdr.isWhitelisted(link);
      cleanedLink=rdr.removeR(link,false);
      containsR=gContextMenu.onLink && (link!=cleanedLink);
      if(containsR) {
        rdr.d('Extracted '+cleanedLink+' from '+link);
        rdr.origlinkURL=new Array(gContextMenu.link,gContextMenu.linkURL,isOnList,cleanedLink);
        if(rdr.enabled && !isOnList) {
          gContextMenu.linkURL=cleanedLink;
          gContextMenu.link.setAttribute("href",cleanedLink);
        }
      }
    } else {
      containsR=true;
      isOnList=rdr.origlinkURL[2];
    }
    rdr.hideById('rdr-copy-clean-link' ,(containsR && rdr.contextCopyClean));
    rdr.hideById('rdr-add-to-list'     ,(containsR && !isOnList && rdr.contextWhitelist));
    rdr.hideById('rdr-remove-from-list',(containsR &&  isOnList && rdr.contextWhitelist));
    rdr.hideById('rdr-open-cleaned'    ,(containsR && (!rdr.enabled || isOnList) && rdr.contextOpen));
    rdr.hideById('rdr-open-uncleaned'  ,(containsR && (rdr.enabled && !isOnList) && rdr.contextOpen));  
    
    document.getElementById('rdr-open-cleaned').setAttribute("tooltiptext",unescape(cleanedLink));
    document.getElementById('rdr-open-uncleaned').setAttribute("tooltiptext",unescape(link));
  },
  
  hideById: function(id,stat) {
    rdr.getById(id).hidden =!stat;
  },
  
  contextMenuClean: function(event) {
    if(event.target.getAttribute('id')=='contentAreaContextMenu') rdr.resetLink();
  },
  
  resetLink: function(dnd) {
    if(dnd) {
      if(!rdr.origlinkURL2) return;
      rdr.d('Cleaning DragDrop Link');
      rdr.origlinkURL2[0].setAttribute('href',rdr.origlinkURL2[1]);
      rdr.origlinkURL2=null;
    } else {
      if(!rdr.origlinkURL) return;
      rdr.d('Cleaning saved Link');
      rdr.origlinkURL[0].setAttribute('href',rdr.origlinkURL[1]);
      rdr.origlinkURL=null;    
    }
  },
  
  addLinkToList: function(link) {
    host=rdr.getHost(unescape(link));
    rdr.d('Added "'+host+' to list (from '+link+' )');
    if(!link || !host) return;
    wl=rdr.prefs.getCharPref("whitelist");
    if(wl.length>0) wl=wl+' ';
    rdr.prefs.setCharPref('whitelist',(wl+host).toLowerCase());
  },
  
  removeLinkFromList: function(link) {
    if(!link || !link.length) return;
    
    try {
      rdr.menu.hidePopup();
    } catch(e) {}
    
    var filter=rdr.isWhitelisted(unescape(link),true);    
    var wl=' '+rdr.prefs.getCharPref("whitelist")+' ';
    
    if(rdr.askBeforeRemoval) {
      prompts = Cc["@mozilla.org/embedcomp/prompt-service;1"].getService(Ci.nsIPromptService);
      flags = prompts.BUTTON_POS_0 * prompts.BUTTON_TITLE_IS_STRING + prompts.BUTTON_POS_1 * prompts.BUTTON_TITLE_CANCEL;
      check={value: true};
      cancelled = prompts.confirmEx(window, rdr.locale.getString('confirmRemoval'), rdr.locale.getFormattedString('confirmRemovalText', [filter]), flags, rdr.locale.getString('confirmRemovalBtn'), "", "", rdr.locale.getString('confirmRemovalAskBefore'), check);
      if(!cancelled && !check.value) rdr.prefs.setBoolPref('askBeforeRemoval',false);
    } else cancelled=false;
    
    if(filter && !cancelled) {
      rdr.d('Removing '+filter+' from list (from '+link+' )');
      rdr.prefs.setCharPref('whitelist',(wl.replace(' '+filter+' ',' ')).replace(/^\s*|\s*$/g,""));
      return;
    }
    
    rdr.d('Removing '+link+' from list failed; cancelled or no matching host found');
  },
  
  copyCleanLink: function() {
    var oCB = Cc["@mozilla.org/widget/clipboardhelper;1"].getService(Ci.nsIClipboardHelper);
    oCB.copyString(rdr.origlinkURL[3]);
  },
  
  openLink: function(link, node) {
    // Execute JS Links in page context
    if(link.indexOf("javascript:")==0 && node) {
      rdr.resetLink();
      var event = document.createEvent("MouseEvents");
      event.initMouseEvent("click", true, true, window, 0, 0, 0, 0, 0, false, false, false, false, 0, null);
      // prevent RDR from intercepting
      rdr.preventClean=true;
      node.dispatchEvent(event);
      rdr.preventClean=false;
      return;
    }
    switch (rdr.contextOpenIn) {
      case 0: // here
        loadOneOrMoreURIs(link);
        break;
      case 2: // new window
        window.open(link);
        break;
      default: // new tab
        var t = gBrowser.addTab(link);
        if(!rdr.prefServ.getBoolPref('browser.tabs.loadInBackground')) {
          gBrowser.selectedTab = t;
          content.focus();
        }
    }
  },
  
  cleanLink: function(link,app) {
    if(!rdr.enabled || rdr.isWhitelisted(link)) return link;     
    l=rdr.removeR(link,app,true);
    if(app && l.indexOf("RDR:")==0 && rdr.changeCursor && rdr.overLink) this.overLink.style.cursor = "url(chrome://rdr/content/rdrmouse.png), pointer";
    return l;
  },
  
  isWhitelisted: function(link,returnFilter) {  
    // rdr.blacklist defaults to false thus it works as whitelist. Switching it... obvious isn't it?  
    if(rdr.whitelist.length==0 || !link || link.length==0) return rdr.blacklist;
    var link=unescape(link.toLowerCase());
    for (var i=0;i<rdr.whitelist.length;i++) {
      var listParts=rdr.whitelist[i].split('*');
      var link2=(listParts[0].match(/^[a-z]+:\/\//)?link:rdr.getHost(link)); 
      var matches=true;
      z=0;
      for (var j in listParts) {
        var x=link2.indexOf(listParts[j]);
        if(x==-1 || x<z) { // not found or not in correct order
          matches=false;
          break;
        } 
        z=x+listParts[j].length;        
      }
      if(matches) {
        if(returnFilter) return rdr.whitelist[i];
        rdr.d('Link '+link+' whitelisted by '+rdr.whitelist[i]);
        return !rdr.blacklist;
      }
    }
    return rdr.blacklist;  
  },
    
  getHost: function (link,node) {
    if(node) link=makeURLAbsolute(node.baseURI, link);  
    var url=link.match(/\/\/(.*?)(?:\/|\?|$)/);
    return (url && url[1].length? url[1] : link).toLowerCase();
  },
  
  removeR: function(link,app,intel) {
    var test=link;
    if(test.toLowerCase().indexOf('abp://')==0) return link;
    
    // Matches rot13 encoded URLs (not, single and double escaped)
    if(test.match(/(?:uggcf?|sgc)(?::\/\/|%3a%2f%2f|%253a%252f%252f)/i)) test=rdr.deRot13(test);    
  	test=rdr.matchLink(test);
    if(!test) {
      // Matches base64 encoded URLs, mixed case
      if(link.match(/((?:[dV][13]d[3X]|[aS][FH]R[0U][cU][HF]?|[RZ][ln]R[Qw])[a-zA-Z0-9+/]+)/))
        return (app?'RDR: ':'')+unescape(rdr.base64decode(RegExp.$1));
      return link;  
    }   
    test=test.replace(/&amp;/g,'&');
    
    if(intel && rdr.intelliWhitelist && rdr.getHost(test)==rdr.getHost(link)) {
      rdr.d('Redirecting to itself: '+test+' from '+link);
      return link;
    }    
    if(!app) rdr.d('Extracted '+test+' from '+link);
    
    return (app?'RDR: ':'')+test;
  },
  
  matchLink: function(link) {
    var re = new RegExp;
  	re.compile(".+((?:https?|ftp)(?:(?::[^?]+[?][^=&]+=.+)|(?:(?:%3a|%253a|:)[^&]+)))", "gi");
  	if(!(r = link.match(re))) return false; // No RDR Found
    
    var ret = unescape(RegExp.$1);
    if (!ret.indexOf('%253a')) return ret; // No double unescaping needed

    ret = unescape(ret);
    if (link.toLowerCase().indexOf('javascript') == 0 && ret.match(/(.+?)[^-%a-z0-9:\/&]+$/gi))
      return RegExp.$1;	// Match Javascript parentheses
    return ret; // only double unescape  
  },
   
  _rot13a: "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ",
  _rot13b: "nopqrstuvwxyzabcdefghijklmNOPQRSTUVWXYZABCDEFGHIJKLM",
  deRot13: function(r) {
    rdr.d('Decoding rot13: '+r);
    var risp='';
    for(i=0; i<r.length; i++) {
      t = r.substr(i,1);
      x = rdr._rot13a.indexOf(t);
      risp += x > -1 ? rdr._rot13b.substr(x,1) : t;
    }
    return risp;
  },
  
  
  _b64: "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",
  base64decode : function (input) {
    rdr.d('Decoding base64: '+input);
		var output = "", chr1, chr2, chr3, enc1, enc2, enc3, enc4, i = 0, m;		
		while (i < input.length) {
			enc1 = rdr._b64.indexOf(input.charAt(i++));
			enc2 = rdr._b64.indexOf(input.charAt(i++));
			enc3 = rdr._b64.indexOf(input.charAt(i++));
			enc4 = rdr._b64.indexOf(input.charAt(i++));
			
			chr1 = (enc1 << 2) | (enc2 >> 4);
			chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
			chr3 = ((enc3 & 3) << 6) | enc4;
			
			output = output + String.fromCharCode(chr1) + String.fromCharCode(chr2) + String.fromCharCode(chr3);
		}
		
		m = input.length%4;
		if(m == 2) return output.slice(0,-2);
	  else if(m == 3) return output.slice(0,-1);		
    return output;
	},
  
  observe: function (subject, topic, data) {
		if (topic == "nsPref:changed") {
			rdr.updatePrefs();
		}
	},
  
  // MetaData Functions
  showAddRem: function(add,rem,id) {
    rdr.hideById("rdr-add-to-list-"+id,add);
    rdr.hideById("rdr-remove-from-list-"+id,rem);
  },
  
  openOptions: function(link,filter) {
    window.openDialog('chrome://rdr/content/prefs.xul','','chrome,modal,centerscreen',link,filter);
  },
  
	d: function(t) {
	  if(rdr.debug) Cc["@mozilla.org/consoleservice;1"].getService(Ci.nsIConsoleService).logStringMessage('RDR: '+t);
  }	
}